#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);

#include "IRremote.h"

IRrecv irrecv(2); // указываем вывод, к которому подключен приемник
decode_results results;
IRsend irsend;


#define BTN 7   // кнопка подключена сюда (PIN --- КНОПКА --- GND) FIRE
boolean btnState, btnFlag;
unsigned long gunFire;
int comcolor = 1;

#define PINb1 4        // кнопка подключена сюда (PIN --- КНОПКА --- GND)butt1
#define PINb2 5        // кнопка подключена сюда (PIN --- КНОПКА --- GND)butt2
#define MODE_AM 4    // количество режимов (от 0 до указанного)

boolean butts_flag = 0;
boolean butts;
unsigned long last_press;


#include "GyverButton.h"

GButton butt1(PINb1);  // создаём нашу "кнопку"
GButton butt2(PINb2);  // создаём нашу "кнопку"
//GButton butt3(PINb3);  // создаём нашу "кнопку"
byte mode = 0;       // переменная режима

//задаем переменные для попаданий 0
int yourLive = 10; // кол-во попаданий для победы
int armore = 30; // кол-во патронов
int timepause = 2000; // пауза между раундами


void setup() {
  Serial.begin(57600); // выставляем скорость COM порта для отладки
  irrecv.enableIRIn(); // запускаем прием

  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.display();
  delay(2000);
  display.clearDisplay();
  
  //pinMode(12, OUTPUT);//fire diod
  
  //damage
  pinMode(A1, OUTPUT); //blue
  pinMode(A2, OUTPUT); //green
  pinMode(A3, OUTPUT); //red
  //white A1+A2+A3
  
  //end game
  pinMode(6, OUTPUT); //end
  
  //select command
  pinMode(BTN, INPUT_PULLUP);

  //reload

  
}



void loop() {


  if ( irrecv.decode( &results )) { // если данные пришли
  Serial.println( results.value, HEX ); // печатаем данные для отладки
    if ( (results.value == 0x2FD847B/*75C0FF8*/) || (results.value == 0xE05993FE) || (results.value == 0xE05993FD) || (results.value == 0x5371C298) ){ //blue
    digitalWrite( A2, LOW );
    digitalWrite( A3, LOW );
    yourLive --;
    digitalWrite( A1, HIGH );
    delay(100);
    digitalWrite( A1, LOW );
    infotable();
    }
    if ( (results.value == 0x98A027A0) || (results.value == 0x719DABA6) || (results.value == 0x719DABA4) || (results.value == 0xD60DBA24) ){ //green
    digitalWrite( A1, LOW );
    digitalWrite( A3, LOW );
    yourLive --;
    digitalWrite( A2, HIGH );
    delay(100);
    digitalWrite( A2, LOW );
    infotable();
    }
    if ( (results.value == 0x1F424C98) ||  (results.value == 0xF83FD09E) || (results.value == 0xF83FD09D) || (results.value == 0x6B57FF38) ){ //red
    digitalWrite( A1, LOW );
    digitalWrite( A2, LOW );
    yourLive --;
    digitalWrite( A3, HIGH );
    delay(100);
    digitalWrite( A3, LOW );
    infotable();
    }
    if ( (results.value == 0xDF30F054) || (results.value == 0xB82E745A) || (results.value == 0xB82E7459) || (results.value == 0x1C9E82D8) ){ //white
    yourLive --;
    digitalWrite( A1, HIGH );
    digitalWrite( A2, HIGH );
    digitalWrite( A3, HIGH );
    delay(100);
    digitalWrite( A1, LOW );
    digitalWrite( A2, LOW );
    digitalWrite( A3, LOW );
    infotable();
    }
    if (yourLive <= 0) {
      digitalWrite( 6, HIGH );
      endGame();
      delay(timepause);
      digitalWrite( 6, LOW );
      digitalWrite( A1, LOW );
      digitalWrite( A2, LOW );
      digitalWrite( A3, LOW );
      yourLive = 10;
      irrecv.resume();
    }
    else
    {
    irrecv.resume(); // принимаем следующую команду
    }
  }
  
  butt1.tick();             // обязательная функция отработки. Должна постоянно опрашиваться
  if (butt1.isPress()) {    // правильная отработка нажатия с защитой от дребезга
    // увеличиваем переменную номера режма. Если вышла за количество режимов - обнуляем
    if (++mode >= MODE_AM) mode = 0;
  }
  // всё переключение в итоге сводится к оператору switch
  switch (mode) {
    case 0: task_0();
      break;
    case 1: task_1();
      break;
    case 2: task_2();
      break;
    case 3: task_3();
      break;
  }

//выстрел
btnState = !digitalRead(BTN);  // читаем состояние кнопки с инверсией. 1 - нажата, 0 - нет
if (btnState && !btnFlag) {    // если нажата и была отпущена (btnFlag 0)
btnFlag = true;              // запомнили что нажата
  if (armore > 0) {
//   digitalWrite( 12, HIGH );
    armore --;
    irsend.sendNEC(gunFire, 32);//fire IRdiod
        delay(40);
  } else {
    endPatr();
  }
    irrecv.enableIRIn();
}
if (!btnState && btnFlag) {    // если отпущена и была нажата (btnFlag 1)
  btnFlag = false;             // запомнили что отпущена
//   digitalWrite( 12, LOW );
  irrecv.enableIRIn();
}

//перезарядка
  butt2.tick();             // обязательная функция отработки. Должна постоянно опрашиваться
  if (butt2.isPress()) {    // правильная отработка нажатия с защитой от дребезга
    armore = 30;
    reloadGun();
  }
}


 // наши задачи, внутри функций понятное дело может быть всё что угодно
void task_0() {
  gunFire = 0x75C0FF8;
  comcolor = 0;
  infotable();
//  Serial.println("Gun Blue");
}
void task_1() {
  gunFire = 0x98A027A0;
  comcolor = 1;
  infotable();
//  Serial.println("Gun Green");
}
void task_2() {
  gunFire = 0x1F424C98;
  comcolor = 2;
  infotable();
//  Serial.println("Gun Red");
}
void task_3() {
  gunFire = 0xDF30F054;
  comcolor = 3;
  infotable();
//  Serial.println("Gun White");
}

void infotable() {
  display.clearDisplay();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 0);
  display.print("com ");
if (comcolor == 0){
    display.println("Blue");
  }
if (comcolor == 1){
    display.println("Green");
  }
if (comcolor == 2){
    display.println("Red");
  }
if (comcolor == 3){
    display.println("White");
  }
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 16);
  display.print("patr ");
  display.println(armore);
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 32);
  display.print("live ");
  display.println(yourLive);
  display.display();
}

void reloadGun(){
  display.clearDisplay();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 0);
  display.print("GUN reload");
  display.display();
  delay(1000);
  }

void endPatr(){
  display.clearDisplay();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 0);
  display.print("Patronov Net");
  display.display();
  delay(1000);
  }

void endGame(){
  display.clearDisplay();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0, 0);
  display.print("Game over");
  display.display();
  }
